Core - Bug # 57751

Status: Resolved Priority: Must have
Author: Robbert V Category: felogin
Created: 2014-04-08 Assigned To: Markus Klein
Updated: 2015-02-20 Due date:

TYPO3 Version: 6.2

PHP Version: 53

Complexity:

Is Regression: No

Sprint Focus:

Subject: Felogin session not set

Description

After upgrading my TYPOS 6.1.7 installation to 6.2.0 the felogin form is working properly anymore. | have been wondering around on
the internet and haven't found someone with the same problem.

As far as i can tell at the moment the felogin extension doesn't set the cookie for fe_typo_user. So if | log in | get redirected to the
correct page, when | want to navigate | end up on de login screen.

There are no errors in console, reports, logs or whatever. Cookie domain is set correctly, also BE login and Install Tool are working
without any prob

Related issues:

related to Core - Bug # 53598: Select/Delete fe_sessions twice per request Resolved 2013-11-13
related to Core - Task # 55549: Only set FE user cookie if session data or us... Resolved 2014-02-01
related to LDAP / SSO Authentication - Bug # 64018: Lost logged in status whe... Closed 2014-12-22
related to Core - Bug # 63597: Felogin session cookie is destroyed when navig... New 2014-12-05
related to Core - Bug # 59614: The property newSessionID is used in a wrong c... Resolved 2014-06-16
related to Core - Bug # 58713: Failed feuser login removes the existing sessi... Resolved 2014-05-12
related to Core - Bug # 58957: Frontend User Session by POST ['recs']['ts'] Needs Feedbacd014-05-20
duplicates Core - Bug # 57746: FE-User Session is deleted on login attempt / ... Closed 2014-04-08
duplicates Core - Bug # 57724: Not logged in after "Forgot your password?" pr... Closed 2014-04-07

Associated revisions

Revision 76741dff - 2014-04-28 16:26 - Markus Klein

[BUGFIX] Session cookie is not recreated on login

In case login data is submitted and there is an existing cookie/session
the current session is discarded and the current cookie is unset.
Subsequently the login data is processed and login succeeds and a
new session is established, but the new cookie is not set.

Fix this be correctly remembering that we need to set a new cookie,
after we disposed the current one.

Resolves: #57751

Releases: 6.2

Change-Id: 12e4b4a381b4e557aeb95c4186c6e5365dbeads2a
Reviewed-on: https://review.typo3.0rg/29626

Reviewed-by: Fabien Udriot
Reviewed-by: Stefan Neufeind
Reviewed-by: Robbert V
Tested-by: Robbert V
Reviewed-by: Frans Saris
Tested-by: Frans Saris
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

History

#1 - 2014-04-08 16:20 - Stanislas Rolland

Same problem after upgrading a site from 4.5 t0 6.2.

#2 - 2014-04-08 21:25 - Stanislas Rolland

Stanislas Rolland wrote:

Same problem after upgrading a site from 4.5 to 6.2.

In my case, after unsetting [SYS][cookieDomain], frontend login works again. So maybe there is a problem there.

#3 - 2014-04-09 07:49 - Stanislas Rolland

Stanislas Rolland wrote:

In my case, after unsetting [SYS][cookieDomain], frontend login works again. So maybe there is a problem there.

Well, a cookie is set, but as soon as the user navigates, he is not logged in anymore.

#4 - 2014-04-09 09:04 - Robbert V

Stanislas Rolland wrote:

Stanislas Rolland wrote:

In my case, after unsetting [SYS][cookieDomain], frontend login works again. So maybe there is a problem there.

Well, a cookie is set, but as soon as the user navigates, he is not logged in anymore.

This is also the case here. The [SYS][cookieDomain] wasn't set before the update, now it's set but not making any difference.

#5 - 2014-04-10 02:19 - Sievert Peter
Have exactly the same problem!

After upgrading from TYPO3 6.1.7 to 6.2.0 felogin don't works correctly.
1.) Starting felogin for sign in, a cookie fe_typo_user is created
2.) After login the correct status "user logged in" is shown, a row in fe_session and fe_session_data is created BUT the cookie fe_typo_user is

DELETED ... therefore the user loose the "log in", that means any following click which force a GET/POST shows the status user logged out.

#6 - 2014-04-10 08:52 - Robbert V

Sievert Peter wrote:

Have exactly the same problem!

After upgrading from TYPO3 6.1.7 to 6.2.0 felogin don't works correctly.

1.) Starting felogin for sign in, a cookie fe_typo_user is created

2.) After login the correct status "user logged in" is shown, a row in fe_session and fe_session_data is created BUT the cookie fe_typo_user is
DELETED ... therefore the user loose the "log in", that means any following click which force a GET/POST shows the status user logged out.

Thanks for the better description, this is the same | have found wrong.

#7 - 2014-04-11 21:40 - Markus Klein

| added some relations to patches that went into 6.2 which might be related.

#8 - 2014-04-11 23:53 - Stanislas Rolland

| think there is more to this misbehaviour. Although the frontend user is shown as logged in, if he is part of a user group that should be given access to

some page, such page does not show up in the menu.

#9 - 2014-04-12 01:52 - Markus Klein

@Stanislas: Can that be a caching issue? Even client side caching?

#10 - 2014-04-12 08:12 - Stanislas Rolland

Markus Klein wrote:

@Stanislas: Can that be a caching issue? Even client side caching?

| doubt it. | have been clearing all caches on both sides.

#11 - 2014-04-12 10:58 - Markus Klein

| feared as much. Need to do an extensive debugging session.

#12 - 2014-04-12 11:15 - Sievert Peter
- Assigned To set to Markus Klein
Hi Markus,

i have updated my actual 6.2 from referenced "Bug #55845: Wrong check removes FE cookie" with file FrontendUserAuthentication.php from
2014-04-12 08:15

Cleared all caches (remove typo3temp an recreated it, BE and FE caches)

unfortunately the same as before, when logging in, the cookie fe_user_cookie is deleted!

My felogin settings:
[FE][checkFeUserPid] = 1
[FE][lockIP] = 0
[FE][loginSecurityLevel] = rsa
[FE][lifetime] = "
[FE][sessionDataLifetime] = 86400
[FE][permalogin] = -1

Working with a subdomain for developement dev.xxxxx

May be something i found out helps to reproduce this problem:

Every time i change

[FE][cookieDomain] =

the login works fine until i close the browser (firefox) and start a new browser session!
For example:

1.Changing [FE][cookieDomain] from Blank to def.mydomain.de

2.Clearing all Caches

3.Login works fine (this means fe_user_cookie will not be removed when logging in)!
4.Closing the Browser and start a new session

5.Loging fails because fe_user_cookie will be removed when loging in!

6.Changing [FE][cookieDomain] from def.mydomain.de to Blank

7.Clearing all Caches

8.Login works fine (this means fe_user_cookie will not be removed when logging in)!

... and so on ... (same effect when using/changing setting [SYS][cookieDomain])

Thanks in advance and best regards!

Peter

#13 - 2014-04-12 11:46 - Markus Klein

Actually, after reading your findings, | think #55845 is the least responsible. Maybe none of the linked issues is responsible.

The cookieDomain stuff is only used in the removeCookie() and setSessionCookie() methods. i.e. if you change the domain, different cookies are
set/removed.

So I'll take this as a starting point to find out, where the cookie/session is removed too often.

#14 - 2014-04-12 12:27 - Markus Klein

A short summary for the current problems:
1. feLogin works, but the cookie is unset and therefore for any subsequent click the user is not logged in anymore
2. feLogin works, but the logged in state is not reflected in menus that should show menu items for logged in users.

2015-08-04 4/8



#15 - 2014-04-12 12:36 - Markus Klein

Number 2 is working for me.

#16 - 2014-04-12 13:47 - Markus Klein

| couldn't reproduce number 1 either.

What are the settings of your login-form?

#17 - 2014-04-12 16:06 - Stanislas Rolland
Markus Klein wrote:
A short summary for the current problems: 1. feLogin works, but the cookie is unset and therefore for any subsequent click the user is not logged

in anymore

2. feLogin works, but the logged in state is not reflected in menus that should show menu items for logged in users.

| found the second problem to be unrelated to this issue. Apparently, felogin does not respect any storagePid setting be it in TypoScript, on the flexform

or both. | will investigate this further, and submit a separate issue.

However, the initial issue remains.

#18 - 2014-04-12 16:17 - Markus Klein

For me it respects the storage pid. both, via TS and flexform.

Can't reproduce number 1 though

#19 - 2014-04-12 16:27 - Markus Klein

- Assigned To deleted (Markus Klein)

#20 - 2014-04-12 20:17 - Stanislas Rolland

Markus Klein wrote:

For me it respects the storage pid. both, via TS and flexform.

You're right. | had [FE][checkFeUserPid] unset.

#21 - 2014-04-12 20:48 - Stanislas Rolland

Not a solution, but a temporary workaround: setting dontSetCookie to FALSE in FrontendUserAuthentication.

#22 - 2014-04-13 02:17 - Sievert Peter
"TYPOS now only sets a frontend user cookie (fe_session) if there is session data or the user is logged in. This minimizes traffic, allows better

optimization of reverse proxies (i.e. varnish). It also makes the setting “dontSetCookie” obsolete."

Sorry, | don't understand your workaround!?

#23 - 2014-04-19 15:35 - Sievert Peter

- Assigned To set to Markus Klein

After updating to 6.2.1 a temporary solution for thiS problem is to set:

public $forceSetCookie = TRUE;

(Line 365 in ../typo3/sysext/core/classes/authentication/AbstractUserAuthentication.php)

After changing the setting, the fe_user_cookie is created corect with the user login!

#24 - 2014-04-21 21:03 - Robbert V

Sievert Peter wrote:

After updating to 6.2.1 a temporary solution for thiS problem is to set:

public $forceSetCookie = TRUE;

(Line 365 in ../typo3/sysext/core/classes/authentication/AbstractUserAuthentication.php)

After changing the setting, the fe_user_cookie is created corect with the user login!

This solution is working for me!

#25 - 2014-04-22 09:39 - Markus Klein

@Robbert: Sure this works, but you now have a cookie whenever a user comes to your site. Not only when the user tries to login. The core strives to
set a cookie only when needed, so this is a workaround that might not fit everybody's needs.

@AIl: Can you please tell my your felogin settings, redirect methods, etc so | can reproduce this?

#26 - 2014-04-22 11:38 - Frans Saris

@Markus:

1. Click on the "password forgotton" link (a cookie is now set)
2. Go back to login form (cookie is still there)

3. Login

Login is successful but cookie is now gone and after click your not logged-in anymore.
#27 - 2014-04-22 17:18 - Xavier Perseguers
I can confirm the problem and the solution (forceSetCookie) when using TYPOS 6.1.8 and Microsoft Internet Explorer 11 on Windows 7 64 bits. | had a
list of files to be downloaded, for authenticated members, secured with naw_secured|, but when using IE the frontend user was not properly

reinstantiated in \TYPO3\CMS\Frontend\Controller\TypoScriptFrontendController::initFEuser and this led to an error to download the file (no user...).

No problem found with other browsers.

#28 - 2014-04-23 17:43 - Markus Klein

@Xavier: This is really strange since the changes referenced here did not go into 6.1 branch.

#29 - 2014-04-23 18:23 - Markus Klein

@frans: Thx for the instructions. | can reproduce this now and will debug tonight.

#30 - 2014-04-23 23:09 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/29626

#31 - 2014-04-23 23:14 - Markus Klein

- Status changed from Under Review to Closed

#32 - 2014-04-23 23:16 - Markus Klein

- Status changed from Closed to Under Review

#33 - 2014-04-23 23:30 - Markus Klein

- Status changed from Under Review to Closed

Closing this in favor of #57751.

#34 - 2014-04-23 23:32 - Markus Klein

- Status changed from Closed to Under Review

Redmine does strange things. If | close other tickets which are somehow related as duplicate to this one, this ticket is always closed too.

#35 - 2014-04-28 16:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:76741dff7b967b88aa1d6e556500a77716c7a97a.
#36 - 2014-05-01 14:09 - Sievert Peter

Works fine :-)

Thanks a lot!!

#37 - 2014-06-16 17:12 - Markus Klein

Fix will be reverted with #59614 as a better solution #58713 was merged.

#38 - 2014-12-03 11:29 - Robbert V

Unfortunately the solution is still not available in latest TYPOS 6.2.7 release.

Previous releases also didn't have this fix with them. After manually adjusting the fix everything works fine.

#39 - 2014-12-03 12:39 - Markus Klein

As written above, the patch for this very ticket has been reverted, but a solution has been merged with #58713.

#40 - 2014-12-04 14:27 - Robbert V

The solution doesn't work for my case. When I'm logged in and navigate through my website | get reverted to the login page en my fe_login cookie is
destroyed.

#41 - 2014-12-04 21:50 - Markus Klein

Robert, please open a new ticket, add your configuration of
[FE][checkFeUserPid]

[FE][lockIP]

[FE][loginSecurityLevel]

[FE][lifetime]

[FE][sessionDatalLifetime]

[FE][permalogin]

to the description, add me as watcher and add a relation to this issue after creating the ticket.

Thanks a lot.
